<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (1.8.0_221) on Tue Jan 19 16:20:21 PST 2021 -->
<title>org.apache.nutch.plugin (apache-nutch 1.18 API)</title>
<meta name="date" content="2021-01-19">
<link rel="stylesheet" type="text/css" href="../../../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="org.apache.nutch.plugin (apache-nutch 1.18 API)";
        }
    }
    catch(err) {
    }
//-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li class="navBarCell1Rev">Package</li>
<li>Class</li>
<li><a href="package-use.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-all.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../org/apache/nutch/parsefilter/regex/package-summary.html">Prev&nbsp;Package</a></li>
<li><a href="../../../../org/apache/nutch/protocol/package-summary.html">Next&nbsp;Package</a></li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?org/apache/nutch/plugin/package-summary.html" target="_top">Frames</a></li>
<li><a href="package-summary.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<div class="header">
<h1 title="Package" class="title">Package&nbsp;org.apache.nutch.plugin</h1>
<div class="docSummary">
<div class="block">The Nutch <a href="../../../../org/apache/nutch/plugin/Pluggable.html" title="interface in org.apache.nutch.plugin"><code>Plugin</code></a> System.</div>
</div>
<p>See:&nbsp;<a href="#package.description">Description</a></p>
</div>
<div class="contentContainer">
<ul class="blockList">
<li class="blockList">
<table class="typeSummary" border="0" cellpadding="3" cellspacing="0" summary="Interface Summary table, listing interfaces, and an explanation">
<caption><span>Interface Summary</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Interface</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tbody>
<tr class="altColor">
<td class="colFirst"><a href="../../../../org/apache/nutch/plugin/Pluggable.html" title="interface in org.apache.nutch.plugin">Pluggable</a></td>
<td class="colLast">
<div class="block">Defines the capability of a class to be plugged into Nutch.</div>
</td>
</tr>
</tbody>
</table>
</li>
<li class="blockList">
<table class="typeSummary" border="0" cellpadding="3" cellspacing="0" summary="Class Summary table, listing classes, and an explanation">
<caption><span>Class Summary</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Class</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tbody>
<tr class="altColor">
<td class="colFirst"><a href="../../../../org/apache/nutch/plugin/Extension.html" title="class in org.apache.nutch.plugin">Extension</a></td>
<td class="colLast">
<div class="block">An <code>Extension</code> is a kind of listener descriptor that will be
 installed on a concrete <code>ExtensionPoint</code> that acts as kind of
 Publisher.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><a href="../../../../org/apache/nutch/plugin/ExtensionPoint.html" title="class in org.apache.nutch.plugin">ExtensionPoint</a></td>
<td class="colLast">
<div class="block">The <code>ExtensionPoint</code> provide meta information of a extension
 point.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><a href="../../../../org/apache/nutch/plugin/Plugin.html" title="class in org.apache.nutch.plugin">Plugin</a></td>
<td class="colLast">
<div class="block">A nutch-plugin is an container for a set of custom logic that provide
 extensions to the nutch core functionality or another plugin that provides an
 API for extending.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><a href="../../../../org/apache/nutch/plugin/PluginClassLoader.html" title="class in org.apache.nutch.plugin">PluginClassLoader</a></td>
<td class="colLast">
<div class="block">The <code>PluginClassLoader</code> is a child-first classloader that only
 contains classes of the runtime libraries setuped in the plugin manifest file
 and exported libraries of plugins that are required plugins.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><a href="../../../../org/apache/nutch/plugin/PluginDescriptor.html" title="class in org.apache.nutch.plugin">PluginDescriptor</a></td>
<td class="colLast">
<div class="block">The <code>PluginDescriptor</code> provide access to all meta information of a
 nutch-plugin, as well to the internationalizable resources and the plugin own
 classloader.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><a href="../../../../org/apache/nutch/plugin/PluginManifestParser.html" title="class in org.apache.nutch.plugin">PluginManifestParser</a></td>
<td class="colLast">
<div class="block">The <code>PluginManifestParser</code> parser just parse the manifest file in
 all plugin directories.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><a href="../../../../org/apache/nutch/plugin/PluginRepository.html" title="class in org.apache.nutch.plugin">PluginRepository</a></td>
<td class="colLast">
<div class="block">The plugin repositority is a registry of all plugins.</div>
</td>
</tr>
</tbody>
</table>
</li>
<li class="blockList">
<table class="typeSummary" border="0" cellpadding="3" cellspacing="0" summary="Exception Summary table, listing exceptions, and an explanation">
<caption><span>Exception Summary</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Exception</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tbody>
<tr class="altColor">
<td class="colFirst"><a href="../../../../org/apache/nutch/plugin/CircularDependencyException.html" title="class in org.apache.nutch.plugin">CircularDependencyException</a></td>
<td class="colLast">
<div class="block"><code>CircularDependencyException</code> will be thrown if a circular
 dependency is detected.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><a href="../../../../org/apache/nutch/plugin/MissingDependencyException.html" title="class in org.apache.nutch.plugin">MissingDependencyException</a></td>
<td class="colLast">
<div class="block"><code>MissingDependencyException</code> will be thrown if a plugin dependency
 cannot be found.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><a href="../../../../org/apache/nutch/plugin/PluginRuntimeException.html" title="class in org.apache.nutch.plugin">PluginRuntimeException</a></td>
<td class="colLast">
<div class="block"><code>PluginRuntimeException</code> will be thrown until a exception in the
 plugin managemnt occurs.</div>
</td>
</tr>
</tbody>
</table>
</li>
</ul>
<a name="package.description">
<!--   -->
</a>
<h2 title="Package org.apache.nutch.plugin Description">Package org.apache.nutch.plugin Description</h2>
<div class="block">The Nutch <a href="../../../../org/apache/nutch/plugin/Pluggable.html" title="interface in org.apache.nutch.plugin"><code>Plugin</code></a> System.
<p>
<b>The Nutch Plugin System provides a way to extend nutch functionality</b>.
A large part of the functionality of Nutch are provided by plugins:
All of the parsing, indexing and searching that nutch does is actually
accomplished by various plugins.
</p><p>
In writing a plugin, you're actually providing one or more extensions of the
existing extension-points (<i>hooks</i>).
The core Nutch extension-points are themselves defined in a plugin,
the <code>nutch-extensionpoints</code> plugin.
Each extension-point defines an interface that must be implemented by the
extension. The core extension-points and extensions available in Nutch are
listed in the <a href="../../../../org/apache/nutch/plugin/Pluggable.html" title="interface in org.apache.nutch.plugin"><code>Pluggable</code></a> interface.
</p></div>
<dl>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="./doc-files/plugin.dtd">Nutch plugin manifest DTD</a>, 
<a href="https://cwiki.apache.org/confluence/display/NUTCH/PluginCentral">
     Plugin Central
     </a>, 
<a href="https://cwiki.apache.org/confluence/display/NUTCH/AboutPlugins">
     About Plugins
     </a>, 
<a href="https://cwiki.apache.org/confluence/display/NUTCH/WhyNutchHasAPluginSystem">
     Why Nutch has a Plugin System?
     </a>, 
<a href="https://cwiki.apache.org/confluence/display/NUTCH/WhichTechnicalConceptsAreBehindTheNutchPluginSystem">
     Which technical concepts are behind the nutch plugin system?
     </a>, 
<a href="https://cwiki.apache.org/confluence/display/NUTCH/WhatsTheProblemWithPluginsAndClass-loading">
     What's the problem with Plugins and Class loading?
     </a>, 
<a href="https://cwiki.apache.org/confluence/display/NUTCH/WritingPluginExample">
     Writing Plugin Example
     </a></dd>
</dl>
</div>
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li class="navBarCell1Rev">Package</li>
<li>Class</li>
<li><a href="package-use.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-all.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../org/apache/nutch/parsefilter/regex/package-summary.html">Prev&nbsp;Package</a></li>
<li><a href="../../../../org/apache/nutch/protocol/package-summary.html">Next&nbsp;Package</a></li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?org/apache/nutch/plugin/package-summary.html" target="_top">Frames</a></li>
<li><a href="package-summary.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy"><small>Copyright &copy; 2021 The Apache Software Foundation</small></p>
</body>
</html>
